
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;


public class Duke extends SkeletonFrame implements Runnable {
    Thread      thread       = null;
    int         sleepTime    = 1000;

    GabriDuke   gabriDuke    = null;

    Button      sendButton   = new Button( "  " );
    Button      startButton  = new Button( " AˊJn " );
    Button      stopButton   = new Button( " A˒~ " );
    TextField   sptmField    = new TextField( "5" );
    Choice      methChoice   = new Choice();

    TextField   codeField    = new TextField( "http://localhost/" );
    TextField[] nameField    = null;
    TextField[] valueField   = null;
    TextField   tnameField   = null;
    TextArea    textArea     = null;

    Choice      randChoice   = new Choice();
    TextField   rslenField   = new TextField( "100" );


    public Duke( GabriDuke gd, Hashtable pmtTable ) {
        gabriDuke = gd;

        setTitle( "Duke" );
        setBackground( Color.lightGray );
        setLayout( null );

        int size = pmtTable.size() - 1;
        width = 640; height = 100 + size * 30 + 20;
        setSize( width, height );

        Label sptmLabel  = new Label( "AˊԊuibj" );
        Label methLabel  = new Label( " METHOD" );
        sendButton. setBounds(  width/2 - 220, 40,  60, 20 );
        startButton.setBounds(  width/2 - 150, 40,  60, 20 );
        stopButton. setBounds(  width/2 -  90, 40,  60, 20 );
        sptmLabel.  setBounds(  width/2 -  20, 40,  80, 20 );
        sptmField.  setBounds(  width/2 +  60, 40,  40, 20 );
        methLabel.  setBounds(  width/2 + 100, 40,  60, 20 );
        methChoice. setBounds(  width/2 + 160, 40,  60, 20 );
        add( sendButton ); add( startButton ); add( stopButton );
        add( sptmLabel ); add( sptmField );
        add( methLabel ); add( methChoice );

        sendButton. addActionListener( this );
        startButton.addActionListener( this );
        stopButton. addActionListener( this );
        methChoice.add( "POST" );
        methChoice.add( "GET" );


        Label codeLabel  = new Label( "bfĥtqk" );
        codeLabel.setBounds(  width/2 - 250, 70, 100, 20 );
        codeField.setBounds(  width/2 - 150, 70, 400, 20 );
        add( codeLabel ); add( codeField );


        nameField     = new TextField[ size ];
        valueField    = new TextField[ size ];
        Enumeration e = pmtTable.keys();

        for ( int i = 0; i < size; i++ ) {
            String key = (String)e.nextElement();
            nameField[i]  = new TextField( key );
            valueField[i] = new TextField( (String)pmtTable.get( key ) );
            add( nameField[i] );
            add( valueField[i] );

            nameField[i]. setBounds(  20, 100 + ( i * 30 ), 100, 25 );
            valueField[i].setBounds( 130, 100 + ( i * 30 ), 150, 25 );
        }


        String key = (String)e.nextElement();
        tnameField  = new TextField( key );
        textArea    = new TextArea( (String)pmtTable.get( key ) );
        tnameField.setBounds( 300, 100, 100, 25 );
        textArea.  setBounds( 300, 130, width - 320, height - 150 );
        add( tnameField );
        add( textArea );


        Label rslenLabel  = new Label( "ő咷" );
        randChoice.setBounds( 420, 100, 100, 20 );
        rslenLabel.setBounds( 520, 100,  40, 20 );
        rslenField.setBounds( 560, 100,  40, 20 );
        add( randChoice ); add( rslenLabel ); add( rslenField );

        randChoice.add( "Random-OFF" );
        randChoice.add( "Random-ON" );


        addWindowListener( this );
    }


    public void start() {
        if ( thread == null ) {
            thread = new Thread( this );
            thread.start();
        }
    }

    public void stop() {
        if ( thread != null ) {
            thread.stop();
            thread = null;
        }
    }

    public void run() {
        try {
            while ( true ) {
                thread.sleep( sleepTime );
                post( makeContent() );
            }
        }
        catch ( InterruptedException e ) {
            System.err.println( "Exception : " + e );
            thread.stop();
        }
    }


    void post( String content ) {
        try {
            String code   = codeField.getText();
            String method = methChoice.getSelectedItem();

            Socket socket  = new Socket( "127.0.0.1", gabriDuke.port );
            PrintWriter pw = new PrintWriter( socket.getOutputStream() );

            if ( method.equals( "GET" ) ) code += ( "?" + content );

            pw.println( method + " " + code + " HTTP/1.0" );

            if ( method.equals( "POST" ) ) {
                pw.println( "Content-length: " + content.length() );
                pw.println();
                pw.println( content );
            }

            pw.println();
            pw.flush();

            pw.close();
            socket.close();

        }
        catch ( Exception e ) {
            System.err.println( "Exception : " + e );
            stop();
        }
    }


    String makeContent() {
        StringBuffer sb = new StringBuffer();
        for ( int i = 0; i < nameField.length; i++ ) {
            sb.append( URLEncoder.encode( nameField[i]. getText() ) );
            sb.append( "=" ); 
            sb.append( URLEncoder.encode( valueField[i].getText() ) + "&" );
        }

        String text;
        if ( randChoice.getSelectedItem().equals("Random-ON") ) {
            int len = 10;
            try {
                len = Integer.parseInt( rslenField.getText() );
            }
            catch ( Exception e ) { }

            char[] c = new char[ (int)( (double)len * Math.random() ) + 1 ];
            for ( int i = 0; i < c.length; i++ ) {
                c[i] = (char)( 95.0d * Math.random() + 32.0d );
            }
            text = new String( c );
        }
        else text = URLEncoder.encode( textArea.getText() );

        sb.append( URLEncoder.encode( tnameField. getText() ) );
        sb.append( "=" ); 
        sb.append( text );

        return( sb.toString() );
    }


    public void actionPerformed( ActionEvent ev ) {
        Object obj = ev.getSource();
        if      ( obj == sendButton )  { post( makeContent() ); }
        else if ( obj == startButton ) {
            try {
                sleepTime = Integer.parseInt( sptmField.getText() ) * 1000;
                if ( sleepTime < 0 )
                    sleepTime = 1000;
                start();
            }
            catch ( Exception e ) { sleepTime = 1000; }
        }
        else if ( obj == stopButton )  { stop();; }
    }


}
